/* Set MAXLINES to the maximum number of lines you wish CE to be able to edit
   I recommend 15,000 not too small, and yet not large enough to impact mem
   in any significant manner */

#define MAXLINES 15000

/* The default filepath where ce will look first for the keymap files
   Note!  You must have a trailing / at the end of the config path! */

#define CONFIG_PATH "/usr/local/lib/ce/"

/* Define this if you want to force ce to prompt for a filename if none
   is given on the command line */

#define FORCE_FILENAME

/* Define this if you wish CE to disallow all shell escapes */

#undef  NOSHELL

/* Define this if you wish CE to disallow the ability to read another file
   into the current document */

#undef  NOIMPORT

/* Define this if you wish CE to disallow the ability to save to a filename
   other than that listed on the command line */

#undef  NOALTNAME

/* Define this if you wish CE to force users to create a local keymap file
   if one does not exist for their terminal type.  If undefined, a message
   is printed stating that a keymap does not exist, and they should contact
   the sys admin, then CE exits. */

#define FORCE_KEYSET

/* DO NOT CHANGE BELOW THIS POINT ! */

#define NUMELM 10
#define MAXNUMSEQ 100
#define UNKNOWN 99
#define PRINTABLE 98
#define CONTROL 97
#define UP 0
#define DOWN 1
#define LEFT 2
#define RIGHT 3
#define FKEY1 4
#define FKEY2 5
#define FKEY3 6
#define FKEY4 7
#define FKEY5 8
#define FKEY6 9
#define FKEY7 10
#define FKEY8 11
#define FKEY9 12
#define FKEY10 13
#define FKEY11 14
#define FKEY12 15
#define BACKSPACE 16
#define DEL 17
#define ESC 18
#define TAB 19
#define RTAB 20
#define CRLF 21
#define PGUP 22
#define PGDOWN 23
#define HOME 24
#define END 25
#define INSERT 26
#define POSSIBLE 96
#define MATCH 2
#define TIMEOUT -5
#define MOREDATA -6
#define CALLOCSIZE 81   /* DO _NOT_ CHANGE! */
#define SCROLLDOWN 200
#define SCROLLUP 201
#define WRAPLEFT 202
#define WRAPRIGHT 203
#define DEFAULT_STATUSMSG "ESC h for help     ESC 1 to save and exit"
#define VERSION "v1.2.06i"
#define MINILINES 3

#ifdef sun
#undef BSD
#define TERMIO
#define TERMIOS
#undef NOSTRSTR
#undef NORINDEX
#undef NO_STDLIB
#endif

#ifdef NeXT
#define BSD
#undef TERMIO
#undef TERMIOS
#undef NOSTRSTR
#undef NORINDEX
#undef NO_STDLIB
#endif

#ifdef convexc
#define BSD
#undef TERMIO
#undef TERMIOS
#undef NOSTRSTR
#undef NORINDEX
#undef NO_STDLIB
#endif

#ifdef u3b2
#undef BSD
#define TERMIO
#undef TERMIOS
#define NOSTRSTR
#define NORINDEX
#define NO_STDLIB
#endif

#ifdef __hpux
#undef BSD
#undef TERMIO
#define TERMIOS
#undef NOSTRSTR
#define NORINDEX
#undef NO_STDLIB
#endif

#ifndef S_ISREG
#define _IFMT           0170000 /* type of file */
#define _IFREG          0100000 /* regular */
#define S_ISREG(m)      (((m)&_IFMT) == _IFREG)
#endif
