/*****************************************************************************
* CE v1.2 Copyright (C) 1991-92, Charles R. Henrich, All Rights Reserved.    *
*                                                                            *
* Use in source and binary forms, with or without modification and           *
* Redistribution without modification are permitted provided that the        *
* following conditions are met:                                              *
*                                                                            *
* 1. Redistributions of source code must retain the above copyright          *
*    notice, all internal copyright notices, this list of conditions         *
*    and the following disclaimer.                                           *
* 2. Redistributions in binary form must reproduce the above copyright       *
*    notice, this list of conditions and the following disclaimer in the     *
*    documentation and/or other materials provided with the distribution.    *
* 3. All advertising materials mentioning features or use of this software   *
*    must display the following acknowledgement:                             *
*      CE Was developed in 1991-92 by Charles Henrich                        *
* 4. Neither the name of this product (CE) nor the name of the author        *
*    (Charles Henrich) may be used to endorse products that include this     *
*    product without specific prior written permission.                      *
* 5. No profit may be made from the inclusion, or distribution of this       *
*    product.  Although a reasonable service charge for the distribution     *
*    of this product is permitted where appropriate.                         *
*                                                                            *
* THIS SOFTWARE IS PROVIDED BY CHARLES HENRICH `` AS IS '' AND ANY EXPRESS   *
* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED          *
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE     *
* DISCLAIMED.  IN NO EVENT SHALL CHARLES HENRICH BE LIABLE FOR ANY DIRECT,   *
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES         *
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR         *
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)         *
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT *
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY  *
* OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF     *
* SUCH DAMAGE.                                                               *
*                                                                            *
*****************************************************************************/

#include <stdio.h>
#include <signal.h>
#include "ce.h"

extern char *help[];
extern int FILELEN;
extern int LINES;
extern int G_mini;
extern int HELPLINES;

void helpwinchange();
extern void winchange();

char *extendedhelp[] =
{
"SAVING/EXITING",
" ",
"ESC 1 or F1        Save and exit",
"ESC 2 or F2        Save and resume editing",
#ifndef NOALTNAME
"ESC 3 or F3        Save with prompt for filename then exit",
#endif
"ESC 4 or F4        Exit and do not save file",
" ",
"NAVIGATING",
" ",
"Control F (PgDown) Page forward through file (beeps on last page)",
"Control B (PgUp)   Page backward through file (beeps on first page)",
"Control G          Goto a line",
"Control Z (Home)   Move cursor to beginning of line",
"Control X          Move cursor to middle of line",
"Control C (End)    Move cursor to end of line",
" ",
"INSERTING",
" ",
"Control P          Insert a blank line at current location",
"Control K          Insert many blank lines at current location",
"Control A          Insert the last line deleted at current location",
" ",
"DELETING",
" ",
"Control D          Delete current line",
"Control N          Delete marked text",
"Control W (DEL)    Erase character under cursor",
"Control E          Erase many characters",
" ",
"MOVING/COPYING",
" ",
"ESC 9 or F9        Begin/End block marking",
"ESC 0 or F10       Clear block markings",
"ESC - or F11       Copy block to current location",
"ESC = or F12       Move block to current location",
" ",
"OTHER",
" ",
"Control R          Search for text",
"Control T (Insert) Toggle between insert and overwrite mode",
#ifndef NOIMPORT
"Control Y          Read a file into text at current location",
#endif
"Control U          Join current line and next together",
"Control O          Set left column and set tab size",
"Control L          Re-draw screen",
"Control V          Show vital statistics about current file",
"ESC m              Toggle Mini menu on or off",
"ESC h              Help",
"ESC s              Save current CE settings",
"ESC k              Create personalized keymap files (try this if your arrow",
"                       keys dont work!)",
#ifndef NOSHELL
"ESC 6 or F6        Save and shell escape #1",
"ESC 7 or F7        Save and shell escape #2",
#endif
" ",
"Note: Every time you save, your previous edit is saved in a file called",
"      <filename>.bak  If you are disconnected, when you reconnect, what you",
"      were working on is saved in a file called cefile.hang",
" ",
"----------------------------------------"
"----------------------------------------",
"Email all bug reports and suggestions to henrich@crs.cl.msu.edu",
" ",
"CE Copyright (C) 1991-92, Charles R. Henrich, All Rights Reserved.",
};

char **minihelp;
char **helppoint;

char *helpmini[] =
{
"----------------------------------------"
"----------------------------------------",

"CTRL F - Page Forward      CTRL B - Page"
" Backward      Press h for extended help",

"----------------------------------------"
"----------------------------------------"
};

char *helpmini1[] =
{
"----------------------------------------"
"----------------------------------------",

"CTRL F - Page Forward      CTRL B - Page"
" Backward                               ",

"----------------------------------------"
"----------------------------------------"
};


char *mainmini[] =
{
"----------------------------------------"
"----------------------------------------",

"  CTRL F  Page forward     CTRL P  Inse"
"rt line     CTRL T  Toggle insert mode",

"  CTRL B  Page back        CTRL D  Delete "
"line     CTRL W  Delete character"
};


void setup_help(void);

static int vlocy, locx, locy, tmpFILELEN, tmpLINES, tmpHELPLINES, tmpgmini;

show_help()
{
int cha, func, count, flag;

#ifdef SIGWINCH
signal(SIGWINCH, helpwinchange);
#endif

flag = vlocy = locx = locy = 0;

ClearScreen();

if(G_mini == 0) LINES-=MINILINES;

tmpgmini = G_mini;

G_mini = 2;

if(helppoint != extendedhelp)
    {
    minihelp = helpmini;
    }
else
    {
    minihelp = helpmini1;
    }

tmpFILELEN = FILELEN;

FILELEN = HELPLINES;

SetScroll(0,LINES);
RedrawScreen(vlocy-locy,helppoint,locx,locy);

while(1)
    {
    getkey(&cha,&func);

    if(func == PRINTABLE && tolower(cha) == 'h' && helppoint != extendedhelp)
        {
        vlocy = locy = 0;
        tmpHELPLINES = HELPLINES;
        helppoint = extendedhelp;
        HELPLINES = (sizeof(extendedhelp) / sizeof(char *) - 1);
        FILELEN = HELPLINES;
        minihelp = helpmini1;
        RedrawScreen(vlocy-locy,helppoint,locx,locy);
        flag = 1;
        continue;
        }

    if(func == PGUP)
        {
        func = CONTROL;
        cha = 'B';
        }

    if(func == PGDOWN)
        {
        func = CONTROL;
        cha = 'F';
        }

    if(func != CONTROL) break;

    if(cha == 'F')
        {
        vlocy=vlocy+LINES-locy;

        if(vlocy > FILELEN || vlocy+LINES > FILELEN)
            {
            vlocy=FILELEN-LINES;
            if(vlocy < 0) vlocy=0;
             putchar('\a');
             }
        RedrawScreen(vlocy,helppoint,locx,locy);
        vlocy=vlocy+locy;
        }

    if(cha == 'B')
        {
        vlocy=vlocy-locy-LINES;

        if (vlocy < 0)
            {
            vlocy=0;
            putchar('\a');
            }

        RedrawScreen(vlocy,helppoint,locx,locy);
        vlocy=vlocy+locy;
        }

    if(cha == 'L')
        {
        RedrawScreen(vlocy-locy,helppoint,locx,locy);
        }
    }

if(flag == 1)
    {
    HELPLINES = tmpHELPLINES;
    helppoint = help;
    }

FILELEN = tmpFILELEN;
G_mini = tmpgmini;
minihelp = mainmini;
if(G_mini == 0) LINES+=MINILINES;

SetScroll(0,LINES);

#ifdef SIGWINCH
signal(SIGWINCH, winchange);
#endif
}

void setup_help(void)
{
extern int HELPLINES;
helppoint = extendedhelp;
HELPLINES = (sizeof(extendedhelp) / sizeof(char *) - 1);
minihelp = mainmini;
}

void helpwinchange()
{
extern int COLUMNS;

ScreenSize(&LINES,&COLUMNS);

LINES--;

if(G_mini > 0) LINES-=MINILINES;

if(locy > LINES)
    {
    vlocy=vlocy-locy;
    locy=0;
    }

/* This editor must have 80 or more columns, if they re-sized the window
   to less, complain LOUDLY */

if (COLUMNS < 80)
    {
    ClearScreen();
    printf("CE Requires 80 columns or more\n\r");
    printf("Please resize your window to this size\n\r");
    MoveCursor(0,0);
    return;
    }

if (COLUMNS > 80) COLUMNS=80;

SetScroll(0,LINES);
RedrawScreen(vlocy-locy,helppoint,locx,locy);
}
